<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: model/level.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: model/level.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/** 
 * @file config
 * @copyright Benedikt Kaffai 2020
 * @license GPLv3
 */

class gLevel {
    constructor(options, graph) {
        this.name = options.name;
        this.schema = options.schema;
        this.cues = [];
        this.graph = graph;
    }
    print() {
        console.log(this.cues);
    }
    export() {
        this.updatePath();

        let file = {
            "name": "registration",
            "chapter": { "chapter": [] },
            "config": {
                "player": [
                    {
                        "name": "Player"
                    }
                ]
            }
        };
        this.cues.forEach(cue => { file.chapter.chapter.push(cue.getData()); });
        return JSON.stringify(file, null, 2);
    }
    getValues() {
        let values = []
        this.cues.forEach(cue => { values.push(cue.getData()); });
        return values
    }

    // this gets called, when flow view is first loaded
    import(level) {      
        this.graph.clear();

        this.name = level.name;
        this.cues = [];
        level.forEach(data => {
            let position = {
                x: parseInt(50),
                y: parseInt(50)
            };
            if (data.hasOwnProperty('view')) {
                if (data.view.hasOwnProperty('position')) {
                    position = {
                        x: parseInt(data.view.position.x),
                        y: parseInt(data.view.position.y)
                    };
                }
            }
            // console.log(`GRAPH: erstelle den Cue: ${data.name}`);
            let cue = new Cue(data, position);
            this.cues.push(cue);
            cue.create();
        });

        // console.log(`GRAPH: zeichne alle ${this.cues.length} Cues `);
        const actionsCells = [].concat(...this.cues.map(c => c.getActionsCells()));
        const cueCells = this.cues.map(c => c.cell);
        graph.addCells(actionsCells.concat(cueCells));
        this.cues.forEach(c => { c.cell.fitEmbeds(c.style) });

        // console.log(`GRAPH: zeichne Verbindungen `);
        this.renderLinks()
        this.updatePath();
    }
    // cue data, position of cue and bool if path for level should be updated
    addCue(data, position) {
        let cue = new Cue(data, position);
        this.cues.push(cue);
        cue.create();
        cue.render();
        this.linkCue(cue.name);
        this.updatePath();
        return cue;
    }
    /**
    * creates all links from and to this cue 
    * if targets of outgoing links don't exist they are skipped
    */
   renderLinks(){
        let cells = [].concat(...this.cues.map(currentCue => {
            return currentCue.getActionsCells().filter(cell => {
                for(let item of cell.attributes.ports.items){                    
                    if (item.group == 'next') return true
                }
                return false;                
            })
        }));
        let links = [];         
        cells.forEach(cell => {
            const ports = cell.attributes.ports.items;
            for (let port of ports) {
                if (port.group == 'next') {
                    let target = this.getCue(port.attrs.info.target);
                    if (target) {
                        let link = new joint.shapes.standard.Link({
                            source: { id: cell.id, port: port.id },
                            target: { id: target.cell.id, port: 'trigger' },
                            router: {
                                name: 'manhattan',
                                args: {
                                    startDirections: ['right'],
                                    endDirections: ['left'],
                                    // step: 10,
                                    // maximumLoops: 200
                                }
                            },
                            connector: { name: 'rounded', radius: 5 },
                            attrs: { line: { stroke: `rgba(85,98,112, .6)` } }
                        });
                        links.push(link);                
                    }
                }
            }
        });
        this.graph.addCells(links);
   }
    linkCue(cueName){
        // console.log(`GRAPH: render ${cueName} links started`);
        // get all cells from other cues connected to this cue and this cues cells
        let cells = [].concat(...this.cues.map(currentCue => {
            return currentCue.getActionsCells().filter(cell => {
                for(let item of cell.attributes.ports.items){
                    if (currentCue.name === cueName || 
                        item.attrs.info.target === cueName) return true
                }
                return false;                
            })
        }));
       
        cells.forEach(cell => {
            const ports = cell.attributes.ports.items;
            for (let port of ports) {
                if (port.group == 'next') {
                    let target = this.getCue(port.attrs.info.target);
                    if (target) {
                        let link = new joint.shapes.standard.Link({
                            source: { id: cell.id, port: port.id },
                            target: { id: target.cell.id, port: 'trigger' },
                            router: {
                                name: 'manhattan',
                                args: {
                                    startDirections: ['right'],
                                    endDirections: ['left'],
                                    // step: 10,
                                    // maximumLoops: 200
                                }
                            },
                            connector: { name: 'rounded', radius: 5 },
                            attrs: { line: { stroke: `rgba(85,98,112, .6)` } }
                        });
                        // link.addTo(this.graph);
                        this.graph.addCell(link)                
                    }
                }
            }
        });
        // console.log(`GRAPH: render ${cueName} links finished`);
    }
    removeLinks() {
        this.graph.getLinks().forEach(link => {
            this.graph.getCell(link.id).remove();
        })
    }
    removeCue(name) {
        let index = this.cues.findIndex(cue => cue.name == name);
        let cue = this.cues[index];
        graph.getCell(cue.cell.id).remove()
        this.cues.splice(index, 1);
        this.updatePath();
    }
    getCue(name) {
        for (let cue of this.cues) {
            if (cue.name.toUpperCase() == name.toUpperCase()) {
                return cue;
            }
        }
        return false;
    }
    getCueByKey(keyString, value) {
        for (let cue of this.cues) {
            let keyArray = keyString.split('.');
            let result = cue;
            for (let key of keyArray) {
                try {
                    result = result[key];
                } catch (error) {
                    break;
                }
            }
            if (result == value) return cue;
        }
        return false;
    }
    /*
    Die Pfad listen der Nodes entwickeln sich über folgende Regeln.

    a) Der erste Node (START) hat einen pfad eintrag in der Liste (main)
    b) Nodes erben jeweils die Pfad Liste des Vorangehenden nodes, der per next angeschlossen ist
    c) Hat ein Node mehrere Vorgänger erhält er die zusammengeführten Pfad listen der Vorgänger. Gleiche einträge werden zusammengefasst, sodass es keine multiplikate in der Liste gibt (merge)
    d) Wenn eine kürzere Liste der Vorgänger Nodes in einer längeren Liste eines Vorgänger nodes enthalten ist, wird die längere Liste dem Node Pfad nicht hinzugefügt. Das verhindert rekursive Pfade, wenn Nodes auf vorgänger nodes weisen.
    e) Enthält ein Node join, wird die Pfad Liste des node der beendet werden soll in die Pfadliste aufgenommen wie in c).
    f) Enthält ein vorangehender Node split, wird ein neuer, bisher ungenutzter Eintrag zur Pfad liste hinzugefügt. Ggf. kann der Eintrag in split spezifiziert werden.
    */
    updatePath(parent=this.getCue('START'), visited = []) {
        if (parent.name === 'START') {
            this.cues.forEach(c => c.data.path = []); // remove all old paths
            this.getCue('START').data.path = ['main']; // Regel a)
        }

        if (!parent) return console.error("no parent to update path");

        // check if current cue (parent) has "join" or "split" and do specific actions
        for (const item in parent.data.session) {
            const property = parent.data.session[item];
            
            if (property.hasOwnProperty("join"))
                parent.addPath(property["join"]); // Regel e)

            if (property.hasOwnProperty("split")) {
                if (Array.isArray(property["split"])) { // 
                    property["split"].forEach(s => {
                        const child = this.getCue(s.next);
                        if (child) child.addPath(s.name); // Regel b)
                    })
                }
                else { // else block follows the old schema and could be removed
                const child = this.getCue(property["split"].next);
                if (child) child.addPath(property["split"].name); // Regel b)
                }
            }

        }

        // from parent walk through every child and its children and transmit paths
        const ancestors = [...visited]; // Teil von Regel d)
        for (const name of [...new Set(Cue.getNext(parent.data, "next"))]) {
            visited = [...ancestors]; // Teil von Regel d). overwrite visited when we jump back from children of child
            const child = this.getCue(name);
            if (child &amp;&amp; child != parent &amp;&amp; !ancestors.includes(name)) { // Regel d)
                child.addPath(parent.data.path); // Regel c)
                visited.push(name);
                this.updatePath(child, visited);
            }
        }

    }

}</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
